\documentclass[tikz, margin={0cm 0cm 0cm 0cm}]{standalone}

\input{utils/preamble}

\begin{document}

\begin{tikzpicture}
    \begin{axis}[
        ybar,
        bar width=3pt,
        % (changed from `xtick`)
        xtick distance=1,
        %xlabel=x values,
        ylabel= avgerage calculation time in ms,
        % (changed to an absolute value)
        enlarge x limits={abs=0.5},
        % ---------------------------------------------------------------------
        % changes to get what you want
        % ---------------------------------------------------------------------
        ymin=0,
        scaled ticks=false,
        % remove the `xticks`
        xtick style={
            /pgfplots/major tick length=0pt,
        },
%        % `ybar interval` is not what you want here I guess, because then e.g.
%        % the last bar is not drawn. To simulate that ...
%        % ... add `extra x ticks` between the `xticks` ...
%       extra x ticks={1.5,...,8.5},
%        % ... without stating any label ...
%        extra x tick labels={},
%        % ... and show the major gridlines
%        extra x tick style={
%            xmajorgrids,
%        },
    ]
        \addplot+ [
            error bars/.cd,
                y dir=both,
                % (changed from `y explicit` so the error bars are (clearly) visible
                y explicit relative,
        ] coordinates {
            (1,9.98) +- (0,0.66)
            (2,8.86) +- (0,0.88)
            (3,6.4)  +- (0,0.63)
            (4,3.17) +- (0,0.72)
        };

        \addplot+ [
            error bars/.cd,
                y dir=both,
                % (changed from `y explicit` so the error bars are (clearly) visible
                y explicit relative,
        ] coordinates {
            (1,6.02) +- (0,0.63)
            (2,4.7)  +- (0,0.67)
            (3,4.4)  +- (0,0.66)
            (4,2.33) +- (0,0.74)
        };

        \addplot+ [
            error bars/.cd,
                y dir=both,
                % (changed from `y explicit` so the error bars are (clearly) visible
                y explicit relative,
        ] coordinates {
            (1,3.36) +- (0,0.70)
            (2,2.86) +- (0,0.73)
            (3,2.27) +- (0,0.87)
            (4,1.51) +- (0,0.96)
        };

        \legend{
            3 delays,
            2 delays,
            one delay,
        }
    \end{axis}
\end{tikzpicture}


\end{document}

